
extern "C"
DWORD WINAPI NtQuerySystemInformation(
    DWORD  SystemInformationClass,
    BYTE*  SystemInformation,
    DWORD  SystemInformationLength,
    DWORD* ReturnLength);

#define SystemProcessInformation 5 

#pragma pack(push)
#pragma pack(1)

typedef struct _SYSTEM_THREAD_INFORMATION {
    LARGE_INTEGER KernelTime;
    LARGE_INTEGER UserTime;
    LARGE_INTEGER CreateTime;
    ULONG WaitTime;
    PVOID StartAddress;
    DWORD /*CLIENT_ID*/ ClientId;
    DWORD /*KPRIORITY*/ Priority;
    LONG BasePriority;
    ULONG ContextSwitches;
    ULONG ThreadState;
    ULONG WaitReason;
} SYSTEM_THREAD_INFORMATION, *PSYSTEM_THREAD_INFORMATION;

typedef struct _SYSTEM_PROCESS_INFORMATION {
    ULONG NextEntryOffset;                     // 00 01 02 03
    ULONG NumberOfThreads;                     // 04 05 06 07
    LARGE_INTEGER SpareLi1;                    // 08 09 0A 0B 0C 0D 0E 0F
    LARGE_INTEGER SpareLi2;                    // 10 11 12 13 14 15 16 17
    LARGE_INTEGER SpareLi3;                    // 18 19 1A 1B 1C 1D 1E 1F
    LARGE_INTEGER CreateTime;                  // 20 21 22 23 24 25 26 27
    LARGE_INTEGER UserTime;                    // 28 29 2A 2B 2C 2D 2E 2F
    LARGE_INTEGER KernelTime;                  // 30 31 32 33 34 35 36 37
    ULONG unk14;                               // 38 39 3A 3B
    WCHAR* ImageName;                          // 3C 3D 3E 3F
    DWORD /*KPRIORITY*/ BasePriority;          // 40 41 42 43
    HANDLE UniqueProcessId;                    // 44 45 46 47
    HANDLE InheritedFromUniqueProcessId;       // 48 49 4A 4B
    ULONG HandleCount;                         //
    ULONG SpareUl2;                            //
    ULONG SpareUl3;                            //
    ULONG PeakVirtualSize;                     //
    ULONG VirtualSize;
    ULONG PageFaultCount;
    ULONG PeakWorkingSetSize;
    ULONG WorkingSetSize;
    ULONG QuotaPeakPagedPoolUsage;
    ULONG QuotaPagedPoolUsage;
    ULONG QuotaPeakNonPagedPoolUsage;
    ULONG QuotaNonPagedPoolUsage;
    ULONG PagefileUsage;
    ULONG PeakPagefileUsage;
    ULONG PrivatePageCount;
    SYSTEM_THREAD_INFORMATION ThreadInfos[1];
} SYSTEM_PROCESS_INFORMATION, *PSYSTEM_PROCESS_INFORMATION;

#pragma pack(pop)
